/*!
 * \file pndaemon.c
 * Demonizing.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <sys/param.h>
#include <sys/stat.h>

#ifndef NOFILES_MAX
  #define NOFILES_MAX 10000
#endif

void demonize(void)
{
	int pid;

#ifdef SIGTTOU
	signal(SIGTTOU, SIG_IGN);
#endif
#ifdef SIGTTIN
	signal(SIGTTIN, SIG_IGN);
#endif
#ifdef SIGTSTP
	signal(SIGTSTP, SIG_IGN);
#endif

	if((pid = fork()) < 0) perror("fork error");
	else if(pid > 0) exit(0);

	if(setpgrp() == -1) perror("setpgrp error");

	signal(SIGHUP, SIG_IGN);

	if((pid = fork()) < 0) perror("fork error");
	else if(pid > 0) exit(0);

/*
	for(fd = 0; fd < NOFILES_MAX; fd++) close(fd);
*/
	umask(0);

	signal(SIGCLD, SIG_IGN);
	signal(SIGALRM, SIG_IGN);
}
