#ifndef __PNL_CLIENT_H
#define __PNL_CLIENT_H

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <hash.h>
#include <pnsock.h>

typedef struct _CLIENT_STRUCT pnclient_t;

struct _CLIENT_STRUCT {
	int sockfd;
	int regist_complete_flag;
	struct sockaddr_in cliaddr;
	time_t timestamp;
	void (*registration_complete)(pnclient_t *);
	int (*regist_completed)(pnclient_t *);
	pnclient_t *next;
};

extern int pnclient_count(void);
extern int pnclient_init(void);
extern pnclient_t *pnclient_create(int sockfd, struct sockaddr_in cliaddr) ;
extern int pnclient_add(pnclient_t *add_cli);
extern int pnclient_delete(pnclient_t *del_cli);
extern hash_t *pnclient_get_hash(void);
extern void pnclient_free(void);
extern pnclient_t *pnclient_lookup(int sockfd);
extern fd_set pnclient_get_fdset(void);
extern int pnclient_get_maxfd(void);
extern time_t pnclient_get_timestamp(pnclient_t *cli);
extern void pnclient_update_timestamp(pnclient_t *cli, time_t unix_secs);


#endif /* __PNL_CLIENT_H */
