#ifndef MOPLIB_LOG_WRITE_H
#define MOPLIB_LOG_WRITE_H

#include <stdio.h>

#define pnlog_fl_warn \
		(pnlog_locate(__FILE__, __LINE__, "WARNNING"), pnlog_print)

#define pnlog_fl_debug \
		(pnlog_locate(__FILE__, __LINE__, "DEBUG"), pnlog_print)

#define pnlog_fl_trace \
		(pnlog_locate(__FILE__, __LINE__, "TRACE"), pnlog_print)

#define pnlog_fl_error \
		(pnlog_locate(__FILE__, __LINE__, "ERROR"), pnlog_print)

#define pnlog_fl_fatal \
		(pnlog_locate(__FILE__, __LINE__, "FATAL ERROR"), pnlog_print) 

#define pnlog_fl_info \
		(pnlog_locate(__FILE__, __LINE__, "INFO"), pnlog_print) 


extern int pnlog_init(const char *dir, const char *prefix, const char *extension);
extern int pnlog_fatal(const char *fmt, ...);
extern int pnlog_error(const char *fmt, ...);
extern int pnlog_warn(const char *fmt, ...);
extern int pnlog_debug(const char *fmt, ...);
extern int pnlog_trace(const char *fmt, ...);
extern int pnlog_info(const char *fmt, ...);
extern int pnlog_hex(const char *ptr, size_t length);
extern int pnlog_hex_t(const char *tag, const char *pp, size_t length);
extern void pnlog_enable(void);
extern void pnlog_disable(void);
extern void pnlog_enable_debug(void);
extern void pnlog_debug_disable(void);
extern void pnlog_close(void);
extern void pnlog_locate(const char *file, int line, const char *log_type);
extern int pnlog_print(const char *fmt, ...);


#endif /* MOPLIB_LOG_WRITE_H */
