/*!
 * \file sock.h
 *
 */
#ifndef __PN_SOCK_H_
#define __PN_SOCK_H_

#include <stdio.h>
#ifdef WIN32
#include <winsock2.h>
#else
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <netdb.h>
#endif
#include "pnsocklog.h"

#define SOCK_DISCONNECTED	101

enum {
	SOCKOPT_SEND_TIMEOUT = 0,
	SOCKOPT_RECV_TIMEOUT,
	SOCKOPT_KEEPALIVE
};

int pnsock_startup(void);
void pnsock_cleanup(void);

extern int pnsock_open(struct sockaddr_in *, unsigned short);
extern int pnsock_accept(int sockfd, struct sockaddr_in *cliaddr, int *clilen);

extern int pnsock_connect(const char *, unsigned short);
extern void pnsock_close(unsigned short int);

extern int pnsock_send(unsigned int, void *, int);
extern int pnsock_send_f(int sock, void *msg, int size);

extern int pnsock_recv(unsigned int, void *, int);
extern int pnsock_recv_f(unsigned int, void *, int);
extern int pnsock_recv_alloc_f(int sockfd, int length, void **rcv_data);

extern void pnsock_setopt(int sockfd, int optname, int optval);


/* socket options */
extern int sock_checkopts (int fd);


#endif	/* __PN_SOCK_H_ */
